import { Time } from '../models/types/time';
import { BetweenDate } from '../models/types/between-date';
import { WeekStartDay } from '../models/types/week-start-day';
export declare class TcDate {
    private internalDate;
    constructor(input?: any);
    get date(): Date;
    set date(value: Date);
    toDate(): number;
    add(amount: number, type: Time): TcDate;
    subtract(amount: number, type: Time): TcDate;
    diff(start: Date, type: Time): number;
    startOf(type: Time, weekStartDay?: WeekStartDay): TcDate;
    endOf(type: Time, weekStartDay?: WeekStartDay): TcDate;
    weekday(): number;
    weekdayToDate(day: number, weekStartDay: WeekStartDay): Date;
    week(weekStartDay: WeekStartDay): number;
    isSame(dateToCheck: Date, type: Time, weekStartDay?: WeekStartDay): boolean;
    isBetween({ start, end }: BetweenDate): boolean;
    isAfter(dateToCheck: Date): boolean;
    isValid(): boolean;
    set(amount: number, type: Time): TcDate;
    daysInMonth(): number;
    toISOString(): string;
    interval(start: Date, end: Date): Date[];
    weekOfYear(date: Date): number;
}
